/**
 * Stub for GtkHotkey.Win32Listener.
 */

#include "gtk-hotkey-win32-listener.h"
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdkwin32.h>
#include <string.h>




struct _GtkHotkeyWin32HotkeyPrivate {
	ATOM _atom;
	GtkHotkeyInfo* _info;
};

#define GTK_HOTKEY_WIN32_HOTKEY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTK_HOTKEY_TYPE_WIN32_HOTKEY, GtkHotkeyWin32HotkeyPrivate))
enum  {
	GTK_HOTKEY_WIN32_HOTKEY_DUMMY_PROPERTY,
	GTK_HOTKEY_WIN32_HOTKEY_ATOM,
	GTK_HOTKEY_WIN32_HOTKEY_INFO
};
static void gtk_hotkey_win32_hotkey_set_atom (GtkHotkeyWin32Hotkey* self, ATOM value);
static void gtk_hotkey_win32_hotkey_set_info (GtkHotkeyWin32Hotkey* self, GtkHotkeyInfo* value);
static gpointer gtk_hotkey_win32_hotkey_parent_class = NULL;
static void gtk_hotkey_win32_hotkey_finalize (GObject* obj);
struct _GtkHotkeyWin32ListenerPrivate {
	GdkWindow* hidden;
	HWND hwnd;
	GHashTable* hotkey_registry;
};

#define GTK_HOTKEY_WIN32_LISTENER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GTK_HOTKEY_TYPE_WIN32_LISTENER, GtkHotkeyWin32ListenerPrivate))
enum  {
	GTK_HOTKEY_WIN32_LISTENER_DUMMY_PROPERTY
};
static void gtk_hotkey_win32_listener_do_remove_hotkey (GtkHotkeyWin32Listener* self, ATOM atom);
static GdkWindow* gtk_hotkey_win32_listener_create_hidden_msg_window (GtkHotkeyWin32Listener* self);
static ATOM gtk_hotkey_win32_listener_atomize (GtkHotkeyWin32Listener* self, GtkHotkeyInfo* hotkey);
static GdkFilterReturn gtk_hotkey_win32_listener_hotkey_filter (GtkHotkeyWin32Listener* self, GdkXEvent* xevt, GdkEvent* evt);
static guint gtk_hotkey_win32_listener_convert_modifier_mask (GtkHotkeyWin32Listener* self, GdkModifierType modifier);
static guint gtk_hotkey_win32_listener_convert_keyval (GtkHotkeyWin32Listener* self, guint keyval);
static ATOM* _win32_atom_dup (ATOM* self);
static void gtk_hotkey_win32_listener_real_bind_hotkey (GtkHotkeyListener* base, GtkHotkeyInfo* hotkey);
static void gtk_hotkey_win32_listener_real_unbind_hotkey (GtkHotkeyListener* base, GtkHotkeyInfo* hotkey);
static GdkFilterReturn _gtk_hotkey_win32_listener_hotkey_filter_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self);
static GObject * gtk_hotkey_win32_listener_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer gtk_hotkey_win32_listener_parent_class = NULL;
static void gtk_hotkey_win32_listener_finalize (GObject* obj);



GtkHotkeyWin32Hotkey* gtk_hotkey_win32_hotkey_construct (GType object_type, ATOM atom, GtkHotkeyInfo* info) {
	GParameter * __params;
	GParameter * __params_it;
	GtkHotkeyWin32Hotkey * self;
	g_return_val_if_fail (info != NULL, NULL);
	__params = g_new0 (GParameter, 2);
	__params_it = __params;
	__params_it->name = "atom";
	g_value_init (&__params_it->value, G_TYPE_UINT);
	g_value_set_uint (&__params_it->value, atom);
	__params_it++;
	__params_it->name = "info";
	g_value_init (&__params_it->value, GTK_HOTKEY_TYPE_INFO);
	g_value_set_object (&__params_it->value, info);
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


GtkHotkeyWin32Hotkey* gtk_hotkey_win32_hotkey_new (ATOM atom, GtkHotkeyInfo* info) {
	return gtk_hotkey_win32_hotkey_construct (GTK_HOTKEY_TYPE_WIN32_HOTKEY, atom, info);
}


ATOM gtk_hotkey_win32_hotkey_get_atom (GtkHotkeyWin32Hotkey* self) {
	g_return_val_if_fail (self != NULL, 0U);
	return self->priv->_atom;
}


static void gtk_hotkey_win32_hotkey_set_atom (GtkHotkeyWin32Hotkey* self, ATOM value) {
	g_return_if_fail (self != NULL);
	self->priv->_atom = value;
	g_object_notify ((GObject *) self, "atom");
}


GtkHotkeyInfo* gtk_hotkey_win32_hotkey_get_info (GtkHotkeyWin32Hotkey* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_info;
}


static void gtk_hotkey_win32_hotkey_set_info (GtkHotkeyWin32Hotkey* self, GtkHotkeyInfo* value) {
	GtkHotkeyInfo* _tmp2;
	GtkHotkeyInfo* _tmp1;
	g_return_if_fail (self != NULL);
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_info = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1)), (self->priv->_info == NULL) ? NULL : (self->priv->_info = (g_object_unref (self->priv->_info), NULL)), _tmp2);
	g_object_notify ((GObject *) self, "info");
}


static void gtk_hotkey_win32_hotkey_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GtkHotkeyWin32Hotkey * self;
	self = GTK_HOTKEY_WIN32_HOTKEY (object);
	switch (property_id) {
		case GTK_HOTKEY_WIN32_HOTKEY_ATOM:
		g_value_set_uint (value, gtk_hotkey_win32_hotkey_get_atom (self));
		break;
		case GTK_HOTKEY_WIN32_HOTKEY_INFO:
		g_value_set_object (value, gtk_hotkey_win32_hotkey_get_info (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gtk_hotkey_win32_hotkey_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GtkHotkeyWin32Hotkey * self;
	self = GTK_HOTKEY_WIN32_HOTKEY (object);
	switch (property_id) {
		case GTK_HOTKEY_WIN32_HOTKEY_ATOM:
		gtk_hotkey_win32_hotkey_set_atom (self, g_value_get_uint (value));
		break;
		case GTK_HOTKEY_WIN32_HOTKEY_INFO:
		gtk_hotkey_win32_hotkey_set_info (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gtk_hotkey_win32_hotkey_class_init (GtkHotkeyWin32HotkeyClass * klass) {
	gtk_hotkey_win32_hotkey_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GtkHotkeyWin32HotkeyPrivate));
	G_OBJECT_CLASS (klass)->get_property = gtk_hotkey_win32_hotkey_get_property;
	G_OBJECT_CLASS (klass)->set_property = gtk_hotkey_win32_hotkey_set_property;
	G_OBJECT_CLASS (klass)->finalize = gtk_hotkey_win32_hotkey_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GTK_HOTKEY_WIN32_HOTKEY_ATOM, g_param_spec_uint ("atom", "atom", "atom", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GTK_HOTKEY_WIN32_HOTKEY_INFO, g_param_spec_object ("info", "info", "info", GTK_HOTKEY_TYPE_INFO, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void gtk_hotkey_win32_hotkey_instance_init (GtkHotkeyWin32Hotkey * self) {
	self->priv = GTK_HOTKEY_WIN32_HOTKEY_GET_PRIVATE (self);
}


static void gtk_hotkey_win32_hotkey_finalize (GObject* obj) {
	GtkHotkeyWin32Hotkey * self;
	self = GTK_HOTKEY_WIN32_HOTKEY (obj);
	{
		GlobalDeleteAtom (self->priv->_atom);
	}
	(self->priv->_info == NULL) ? NULL : (self->priv->_info = (g_object_unref (self->priv->_info), NULL));
	G_OBJECT_CLASS (gtk_hotkey_win32_hotkey_parent_class)->finalize (obj);
}


GType gtk_hotkey_win32_hotkey_get_type (void) {
	static GType gtk_hotkey_win32_hotkey_type_id = 0;
	if (gtk_hotkey_win32_hotkey_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GtkHotkeyWin32HotkeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gtk_hotkey_win32_hotkey_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GtkHotkeyWin32Hotkey), 0, (GInstanceInitFunc) gtk_hotkey_win32_hotkey_instance_init, NULL };
		gtk_hotkey_win32_hotkey_type_id = g_type_register_static (G_TYPE_OBJECT, "GtkHotkeyWin32Hotkey", &g_define_type_info, 0);
	}
	return gtk_hotkey_win32_hotkey_type_id;
}


static void gtk_hotkey_win32_listener_do_remove_hotkey (GtkHotkeyWin32Listener* self, ATOM atom) {
	g_return_if_fail (self != NULL);
	UnregisterHotKey (self->priv->hwnd, atom);
	g_hash_table_remove (self->priv->hotkey_registry, &atom);
}


/**
     * "Ported" from GTK+ SVN revision 20900, file
     * </modules/engines/ms-windows/msw_theme_main.c>.
     * Licensed under the LGPL-2 or later.
     */
static GdkWindow* gtk_hotkey_win32_listener_create_hidden_msg_window (GtkHotkeyWin32Listener* self) {
	GdkWindowAttr _tmp0 = {0};
	GdkWindowAttr attributes;
	gint attributes_mask;
	g_return_val_if_fail (self != NULL, NULL);
	attributes = (memset (&_tmp0, 0, sizeof (GdkWindowAttr)), _tmp0);
	attributes_mask = 0;
	attributes.x = -100;
	attributes.y = -100;
	attributes.width = 10;
	attributes.height = 10;
	attributes.window_type = GDK_WINDOW_TEMP;
	attributes.wclass = GDK_INPUT_ONLY;
	attributes.override_redirect = TRUE;
	attributes.event_mask = 0;
	attributes_mask = (gint) ((GDK_WA_X | GDK_WA_Y) | GDK_WA_NOREDIR);
	return gdk_window_new (gdk_get_default_root_window (), &attributes, attributes_mask);
}


static ATOM gtk_hotkey_win32_listener_atomize (GtkHotkeyWin32Listener* self, GtkHotkeyInfo* hotkey) {
	char* key;
	ATOM atom;
	char* _tmp1;
	char* _tmp0;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (hotkey != NULL, 0U);
	key = NULL;
	atom = 0U;
	_tmp1 = NULL;
	_tmp0 = NULL;
	key = (_tmp1 = g_strconcat (_tmp0 = g_strconcat (gtk_hotkey_info_get_application_id (hotkey), ":", NULL), gtk_hotkey_info_get_key_id (hotkey), NULL), key = (g_free (key), NULL), _tmp1);
	_tmp0 = (g_free (_tmp0), NULL);
	atom = GlobalFindAtom (key);
	if (atom == 0) {
		ATOM _tmp2;
		return (_tmp2 = GlobalAddAtom (key), key = (g_free (key), NULL), _tmp2);
	} else {
		ATOM _tmp3;
		return (_tmp3 = atom, key = (g_free (key), NULL), _tmp3);
	}
	key = (g_free (key), NULL);
}


static GdkFilterReturn gtk_hotkey_win32_listener_hotkey_filter (GtkHotkeyWin32Listener* self, GdkXEvent* xevt, GdkEvent* evt) {
	MSG* p_msg;
	MSG msg;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (xevt != NULL, 0);
	p_msg = (MSG*) xevt;
	msg = *p_msg;
	if (msg.message == WM_HOTKEY) {
		GtkHotkeyWin32Hotkey* _tmp1;
		ATOM _tmp0;
		GtkHotkeyWin32Hotkey* wh;
		_tmp1 = NULL;
		wh = (_tmp1 = (GtkHotkeyWin32Hotkey*) g_hash_table_lookup (self->priv->hotkey_registry, (_tmp0 = (ATOM) msg.wParam, &_tmp0)), (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
		if (wh != NULL) {
			GdkFilterReturn _tmp2;
			g_signal_emit_by_name ((GtkHotkeyListener*) self, "activated", gtk_hotkey_win32_hotkey_get_info (wh));
			return (_tmp2 = GDK_FILTER_REMOVE, (wh == NULL) ? NULL : (wh = (g_object_unref (wh), NULL)), _tmp2);
		}
		(wh == NULL) ? NULL : (wh = (g_object_unref (wh), NULL));
	}
	return GDK_FILTER_CONTINUE;
}


static guint gtk_hotkey_win32_listener_convert_modifier_mask (GtkHotkeyWin32Listener* self, GdkModifierType modifier) {
	guint win32_modifier;
	gboolean _tmp0;
	g_return_val_if_fail (self != NULL, 0U);
	win32_modifier = (guint) 0;
	if ((modifier & GDK_SHIFT_MASK) != 0) {
		win32_modifier = win32_modifier | (MOD_SHIFT);
	}
	if ((modifier & GDK_CONTROL_MASK) != 0) {
		win32_modifier = win32_modifier | (MOD_CONTROL);
	}
	if ((modifier & GDK_MOD1_MASK) != 0) {
		win32_modifier = win32_modifier | (MOD_ALT);
	}
	_tmp0 = FALSE;
	if ((modifier & GDK_SUPER_MASK) != 0) {
		_tmp0 = TRUE;
	} else {
		_tmp0 = (modifier & GDK_HYPER_MASK) != 0;
	}
	if (_tmp0) {
		win32_modifier = win32_modifier | (MOD_WIN);
	}
	return win32_modifier;
}


static guint gtk_hotkey_win32_listener_convert_keyval (GtkHotkeyWin32Listener* self, guint keyval) {
	GdkKeymap* km;
	gint keys_length1;
	GdkKeymapKey* keys;
	g_return_val_if_fail (self != NULL, 0U);
	km = NULL;
	keys = (keys_length1 = 0, NULL);
	km = gdk_keymap_get_default ();
	if (gdk_keymap_get_entries_for_keyval (km, keyval, &keys, &keys_length1)) {
		return keys[0].keycode;
	} else {
		return (guint) 0;
	}
}


static ATOM* _win32_atom_dup (ATOM* self) {
	return g_memdup (self, sizeof (ATOM));
}


static void gtk_hotkey_win32_listener_real_bind_hotkey (GtkHotkeyListener* base, GtkHotkeyInfo* hotkey) {
	GtkHotkeyWin32Listener * self;
	GtkHotkeyWin32Hotkey* wh;
	ATOM atom;
	self = (GtkHotkeyWin32Listener*) base;
	g_return_if_fail (hotkey != NULL);
	wh = NULL;
	atom = gtk_hotkey_win32_listener_atomize (self, hotkey);
	wh = (GtkHotkeyWin32Hotkey*) g_hash_table_lookup (self->priv->hotkey_registry, &atom);
	if (wh == NULL) {
		gboolean result;
		guint keyval;
		guint modifier;
		guint keycode;
		GdkModifierType gdk_modifier;
		result = FALSE;
		keyval = 0U;
		modifier = 0U;
		keycode = 0U;
		gdk_modifier = 0;
		gtk_accelerator_parse (gtk_hotkey_info_get_signature (hotkey), &keyval, &gdk_modifier);
		modifier = gtk_hotkey_win32_listener_convert_modifier_mask (self, gdk_modifier);
		keycode = gtk_hotkey_win32_listener_convert_keyval (self, keyval);
		result = RegisterHotKey (self->priv->hwnd, atom, modifier, keycode);
		if (result) {
			ATOM* _tmp0;
			g_hash_table_insert (self->priv->hotkey_registry, (_tmp0 = &atom, (_tmp0 == NULL) ? NULL : _win32_atom_dup (_tmp0)), gtk_hotkey_win32_hotkey_new (atom, hotkey));
		}
	}
}


static void gtk_hotkey_win32_listener_real_unbind_hotkey (GtkHotkeyListener* base, GtkHotkeyInfo* hotkey) {
	GtkHotkeyWin32Listener * self;
	GtkHotkeyWin32Hotkey* wh;
	ATOM atom;
	self = (GtkHotkeyWin32Listener*) base;
	g_return_if_fail (hotkey != NULL);
	wh = NULL;
	atom = gtk_hotkey_win32_listener_atomize (self, hotkey);
	wh = (GtkHotkeyWin32Hotkey*) g_hash_table_lookup (self->priv->hotkey_registry, &atom);
	if (wh != NULL) {
		gtk_hotkey_win32_listener_do_remove_hotkey (self, atom);
	}
}


GtkHotkeyWin32Listener* gtk_hotkey_win32_listener_construct (GType object_type) {
	GtkHotkeyWin32Listener * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


GtkHotkeyWin32Listener* gtk_hotkey_win32_listener_new (void) {
	return gtk_hotkey_win32_listener_construct (GTK_HOTKEY_TYPE_WIN32_LISTENER);
}


static GdkFilterReturn _gtk_hotkey_win32_listener_hotkey_filter_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self) {
	return gtk_hotkey_win32_listener_hotkey_filter (self, xevent, event);
}


static GObject * gtk_hotkey_win32_listener_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GtkHotkeyWin32ListenerClass * klass;
	GObjectClass * parent_class;
	GtkHotkeyWin32Listener * self;
	klass = GTK_HOTKEY_WIN32_LISTENER_CLASS (g_type_class_peek (GTK_HOTKEY_TYPE_WIN32_LISTENER));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GTK_HOTKEY_WIN32_LISTENER (obj);
	{
		GdkWindow* _tmp0;
		GHashTable* _tmp1;
		_tmp0 = NULL;
		self->priv->hidden = (_tmp0 = gtk_hotkey_win32_listener_create_hidden_msg_window (self), (self->priv->hidden == NULL) ? NULL : (self->priv->hidden = (g_object_unref (self->priv->hidden), NULL)), _tmp0);
		self->priv->hwnd = GDK_WINDOW_HWND (self->priv->hidden);
		_tmp1 = NULL;
		self->priv->hotkey_registry = (_tmp1 = g_hash_table_new (g_int_hash, g_int_equal), (self->priv->hotkey_registry == NULL) ? NULL : (self->priv->hotkey_registry = (g_hash_table_unref (self->priv->hotkey_registry), NULL)), _tmp1);
		gdk_window_add_filter (self->priv->hidden, _gtk_hotkey_win32_listener_hotkey_filter_gdk_filter_func, self);
	}
	return obj;
}


static void gtk_hotkey_win32_listener_class_init (GtkHotkeyWin32ListenerClass * klass) {
	gtk_hotkey_win32_listener_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GtkHotkeyWin32ListenerPrivate));
	G_OBJECT_CLASS (klass)->constructor = gtk_hotkey_win32_listener_constructor;
	G_OBJECT_CLASS (klass)->finalize = gtk_hotkey_win32_listener_finalize;
	GTK_HOTKEY_LISTENER_CLASS (klass)->bind_hotkey = gtk_hotkey_win32_listener_real_bind_hotkey;
	GTK_HOTKEY_LISTENER_CLASS (klass)->unbind_hotkey = gtk_hotkey_win32_listener_real_unbind_hotkey;
}


static void gtk_hotkey_win32_listener_instance_init (GtkHotkeyWin32Listener * self) {
	self->priv = GTK_HOTKEY_WIN32_LISTENER_GET_PRIVATE (self);
	self->priv->hidden = NULL;
}


static void gtk_hotkey_win32_listener_finalize (GObject* obj) {
	GtkHotkeyWin32Listener * self;
	self = GTK_HOTKEY_WIN32_LISTENER (obj);
	{
		GList* keys;
		GdkWindow* _tmp2;
		keys = g_hash_table_get_keys (self->priv->hotkey_registry);
		{
			GList* atom_collection;
			GList* atom_it;
			atom_collection = keys;
			for (atom_it = atom_collection; atom_it != NULL; atom_it = atom_it->next) {
				ATOM atom;
				atom = *((ATOM*) atom_it->data);
				{
					gtk_hotkey_win32_listener_do_remove_hotkey (self, atom);
				}
			}
		}
		gdk_window_remove_filter (self->priv->hidden, _gtk_hotkey_win32_listener_hotkey_filter_gdk_filter_func, self);
		/* XXX Fix VAPI*/
		gdk_window_destroy (self->priv->hidden);
		_tmp2 = NULL;
		self->priv->hidden = (_tmp2 = NULL, (self->priv->hidden == NULL) ? NULL : (self->priv->hidden = (g_object_unref (self->priv->hidden), NULL)), _tmp2);
		(keys == NULL) ? NULL : (keys = (g_list_free (keys), NULL));
	}
	(self->priv->hidden == NULL) ? NULL : (self->priv->hidden = (g_object_unref (self->priv->hidden), NULL));
	(self->priv->hotkey_registry == NULL) ? NULL : (self->priv->hotkey_registry = (g_hash_table_unref (self->priv->hotkey_registry), NULL));
	G_OBJECT_CLASS (gtk_hotkey_win32_listener_parent_class)->finalize (obj);
}


GType gtk_hotkey_win32_listener_get_type (void) {
	static GType gtk_hotkey_win32_listener_type_id = 0;
	if (gtk_hotkey_win32_listener_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GtkHotkeyWin32ListenerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gtk_hotkey_win32_listener_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GtkHotkeyWin32Listener), 0, (GInstanceInitFunc) gtk_hotkey_win32_listener_instance_init, NULL };
		gtk_hotkey_win32_listener_type_id = g_type_register_static (GTK_HOTKEY_TYPE_LISTENER, "GtkHotkeyWin32Listener", &g_define_type_info, 0);
	}
	return gtk_hotkey_win32_listener_type_id;
}




