/**
 * Stub for GtkHotkey.Win32Listener.
 */

#ifndef __GTK_HOTKEY_WIN32_LISTENER_H__
#define __GTK_HOTKEY_WIN32_LISTENER_H__

#include <glib.h>
#include <glib-object.h>
#include <windows.h>
#include "gtk-hotkey-listener.h"
#include "gtk-hotkey-info.h"

G_BEGIN_DECLS


#define GTK_HOTKEY_TYPE_WIN32_HOTKEY (gtk_hotkey_win32_hotkey_get_type ())
#define GTK_HOTKEY_WIN32_HOTKEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_HOTKEY_TYPE_WIN32_HOTKEY, GtkHotkeyWin32Hotkey))
#define GTK_HOTKEY_WIN32_HOTKEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GTK_HOTKEY_TYPE_WIN32_HOTKEY, GtkHotkeyWin32HotkeyClass))
#define GTK_HOTKEY_IS_WIN32_HOTKEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_HOTKEY_TYPE_WIN32_HOTKEY))
#define GTK_HOTKEY_IS_WIN32_HOTKEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_HOTKEY_TYPE_WIN32_HOTKEY))
#define GTK_HOTKEY_WIN32_HOTKEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_HOTKEY_TYPE_WIN32_HOTKEY, GtkHotkeyWin32HotkeyClass))

typedef struct _GtkHotkeyWin32Hotkey GtkHotkeyWin32Hotkey;
typedef struct _GtkHotkeyWin32HotkeyClass GtkHotkeyWin32HotkeyClass;
typedef struct _GtkHotkeyWin32HotkeyPrivate GtkHotkeyWin32HotkeyPrivate;

#define GTK_HOTKEY_TYPE_WIN32_LISTENER (gtk_hotkey_win32_listener_get_type ())
#define GTK_HOTKEY_WIN32_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_HOTKEY_TYPE_WIN32_LISTENER, GtkHotkeyWin32Listener))
#define GTK_HOTKEY_WIN32_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GTK_HOTKEY_TYPE_WIN32_LISTENER, GtkHotkeyWin32ListenerClass))
#define GTK_HOTKEY_IS_WIN32_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_HOTKEY_TYPE_WIN32_LISTENER))
#define GTK_HOTKEY_IS_WIN32_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_HOTKEY_TYPE_WIN32_LISTENER))
#define GTK_HOTKEY_WIN32_LISTENER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_HOTKEY_TYPE_WIN32_LISTENER, GtkHotkeyWin32ListenerClass))

typedef struct _GtkHotkeyWin32Listener GtkHotkeyWin32Listener;
typedef struct _GtkHotkeyWin32ListenerClass GtkHotkeyWin32ListenerClass;
typedef struct _GtkHotkeyWin32ListenerPrivate GtkHotkeyWin32ListenerPrivate;

struct _GtkHotkeyWin32Hotkey {
	GObject parent_instance;
	GtkHotkeyWin32HotkeyPrivate * priv;
};

struct _GtkHotkeyWin32HotkeyClass {
	GObjectClass parent_class;
};

struct _GtkHotkeyWin32Listener {
	GtkHotkeyListener parent_instance;
	GtkHotkeyWin32ListenerPrivate * priv;
};

struct _GtkHotkeyWin32ListenerClass {
	GtkHotkeyListenerClass parent_class;
};


GtkHotkeyWin32Hotkey* gtk_hotkey_win32_hotkey_construct (GType object_type, ATOM atom, GtkHotkeyInfo* info);
GtkHotkeyWin32Hotkey* gtk_hotkey_win32_hotkey_new (ATOM atom, GtkHotkeyInfo* info);
ATOM gtk_hotkey_win32_hotkey_get_atom (GtkHotkeyWin32Hotkey* self);
GtkHotkeyInfo* gtk_hotkey_win32_hotkey_get_info (GtkHotkeyWin32Hotkey* self);
GType gtk_hotkey_win32_hotkey_get_type (void);
GtkHotkeyWin32Listener* gtk_hotkey_win32_listener_construct (GType object_type);
GtkHotkeyWin32Listener* gtk_hotkey_win32_listener_new (void);
GType gtk_hotkey_win32_listener_get_type (void);


G_END_DECLS

#endif
