using GLib;

namespace GtkHotkey {

/* Delegates */


/*delegate void SearcherGotProperty		(string prop_name, Value value, pointer user_data);
delegate void SearcherGotSessionHandle	(string session_handle, pointer user_data);
delegate void SearcherGotSearchHandle	(string search_handle, pointer user_data);
delegate void SearcherGotHits		(PtrArray hits, pointer user_data);
delegate void SearcherGotHitCount		(uint hit_count, pointer user_data);
delegate void SearcherGotState		(List<string> state_info, pointer user_data);
delegate void SearcherVoidResponse	(pointer user_data);*/




public abstract class Storage : Object {

	public Storage get_default ()
	{
		return null;
	}

	public abstract Info get_hotkey (string app_id, string key_id) throws Error;

	public abstract List<Info> get_application_hotkeys (string app_id) throws Error;

	public abstract List<Info> get_all_hotkeys ();

	public abstract void store_hotkey (Info info) throws Error;

	public abstract bool delete_hotkey (string app_id, string key_id) throws Error;

	public abstract bool has_hotkey (string app_id, string key_id);

	/* Signals */

	public signal void hotkey_stored (Info info);

	public signal void hotkey_deleted (Info info);
}

}
