namespace Win32 {
	[CCode (cname = "MAKELPARAM", cheader_filename = "windows.h")]
	public static long make_lparam (ushort low, ushort high);
	[SimpleType]
	[CCode (cname = "HWND", cheader_filename = "windows.h")]
	public struct WindowHandle {
		[CCode (cname = "GDK_WINDOW_HWND", cheader_filename = "gdk/gdkwin32.h")]
		public static WindowHandle from_gdk_window (Gdk.Window window);
	}
	[SimpleType]
	[CCode (cname = "ATOM", cheader_filename = "windows.h", type_id = "G_TYPE_UINT", marshaller_type_name = "UINT", get_value_function = "g_value_get_uint", set_value_function = "g_value_set_uint", default_value = "0U")]
	[IntegerType (rank = 7)]
	public struct Atom {
		[CCode (cname = "GlobalAddAtom")]
		public static Atom add_global (string str);
		[CCode (cname = "GlobalFindAtom")]
		public static Atom find_global (string str);
		[CCode (cname = "GlobalDeleteAtom")]
		public Atom delete_global ();
	}
	[CCode (cname = "POINT", cheader_filename = "windows.h")]
	public struct Point {
		public long x;
		public long y;
	}
	[CCode (cname = "MSG", cheader_filename = "windows.h")]
	public struct Message {
		public WindowHandle hwnd;
		public uint message;
		public uint wParam; // WPARAM
		public long lParam; // LPARAM
		public ulong time; // DWORD
		public Point pt;
		[CCode (cname = "WM_HOTKEY")]
		public static uint HOTKEY;
		[CCode (cname = "SendMessage")]
		public static long send (WindowHandle hwnd, uint msg,
		                         uint wparam, long lparam);
	}
	[Compact]
	[CCode (cheader_filename = "windows.h")]
	public class HotKey {
		[CCode (cname = "MOD_ALT")]
		public static uint MOD_ALT;
		[CCode (cname = "MOD_CONTROL")]
		public static uint MOD_CONTROL;
		[CCode (cname = "MOD_SHIFT")]
		public static uint MOD_SHIFT;
		[CCode (cname = "MOD_WIN")]
		public static uint MOD_WIN;
		[CCode (cname = "VK_F10")]
		public static uint VK_F10;
		[CCode (cname = "RegisterHotKey")]
		public static bool register (WindowHandle hwnd, Atom id,
		                             uint fs_modifiers, uint vk);
		[CCode (cname = "UnregisterHotKey")]
		public static bool unregister (WindowHandle hwnd, Atom id);
	}
}
